You can control whether to show the table's header or footer, whether to display an alternating row style or column style, and whether to highlight the first column or the last column. For example:
SpreadJS supports built-in table styles or you can customize the table style. For example:
SpreadJS supports customize the style of the table header, data or footer, the table column header, data or footer. Using code such as the following:
window.onload = function() {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
initSpread(spread);
};
function setStyles (sheet) {
let table = sheet.tables.all()[0];
sheet.suspendPaint();
let tableHeaderStyle = new GC.Spread.Sheets.Style();
tableHeaderStyle.backColor = "Accent 1 80";
let tableDataStyle = new GC.Spread.Sheets.Style();
tableDataStyle.backColor = "Accent 4 80";
let tableFooterStyle = new GC.Spread.Sheets.Style();
tableFooterStyle.backColor = "Accent 6 80";
table.layoutStyle({
header: tableHeaderStyle,
data: tableDataStyle,
footer: tableFooterStyle
});
let tableColumnHeaderStyle = new GC.Spread.Sheets.Style();
tableColumnHeaderStyle.backColor = "Accent 1 40";
let tableColumnDataStyle = new GC.Spread.Sheets.Style();
tableColumnDataStyle.backColor = "Accent 4 40";
let tableColumnFooterStyle = new GC.Spread.Sheets.Style();
tableColumnFooterStyle.backColor = "Accent 6 40";
table.columnLayoutStyle(1, {
header: tableColumnHeaderStyle,
data: tableColumnDataStyle,
footer: tableColumnFooterStyle
});
let tableColumn3DataStyle = new GC.Spread.Sheets.Style();
tableColumn3DataStyle.formatter = "0%";
table.columnLayoutStyle(3, {
data: tableColumn3DataStyle
});
sheet.resumePaint();
}
function getActiveSheetTable (sheet) {
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex()) || sheet.tables.all()[0];
return table;
}
function initCustomThemes(spread) {
const theme1 = new GC.Spread.Sheets.Tables.TableTheme();
theme1.name('custom1');
theme1.wholeTableStyle(new GC.Spread.Sheets.Tables.TableStyle('#e0f2f1'));
theme1.headerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.firstRowStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#b2dfdb'));
theme1.firstColumnStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#b2dfdb'));
theme1.footerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.highlightFirstColumnStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.highlightLastColumnStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
const theme2 = new GC.Spread.Sheets.Tables.TableTheme();
theme2.name('custom2');
theme2.wholeTableStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6'));
theme2.headerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6', '#000'));
theme2.firstRowStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#e1bee7'));
theme2.firstColumnStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#e1bee7'));
theme2.footerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6', '#000'));
spread.customTableThemes.add(theme1);
spread.customTableThemes.add(theme2);
let options = _getElementById("tableStyles").innerHTML;
const customThemes = spread.customTableThemes.all();
if (customThemes && customThemes.length > 0) {
customThemes.forEach((theme) => {
options += `<option>${theme.name()}</option>`;
});
}
_getElementById("tableStyles").innerHTML = options;
}
function initSpread(spread) {
var spreadNS = GC.Spread.Sheets;
spread.fromJSON(jsonData);
initCustomThemes(spread);
var sheet = spread.getActiveSheet();
setStyles(sheet);
_getElementById("showHeader").addEventListener('change', function() {
var sheet = spread.getActiveSheet();
var table = getActiveSheetTable(sheet);
if (table) {
table.showHeader(_getElementById("showHeader").checked);
sheet.invalidateLayout();
sheet.repaint();
}
});
_getElementById("showFooter").addEventListener('change', function() {
var sheet = spread.getActiveSheet();
var table = getActiveSheetTable(sheet);
if (table) {
table.showFooter(_getElementById("showFooter").checked);
sheet.invalidateLayout();
sheet.repaint();
}
});
_getElementById("highlightFirstColumn").addEventListener('change', function() {
var sheet = spread.getActiveSheet();
var table = getActiveSheetTable(sheet);
if (table) {
table.highlightFirstColumn(_getElementById("highlightFirstColumn").checked);
sheet.invalidateLayout();
sheet.repaint();
}
});
_getElementById("highlightLastColumn").addEventListener('change', function() {
var sheet = spread.getActiveSheet();
var table = getActiveSheetTable(sheet);
if (table) {
table.highlightLastColumn(_getElementById("highlightLastColumn").checked);
sheet.invalidateLayout();
sheet.repaint();
}
});
_getElementById("bandRows").addEventListener('change', function() {
var sheet = spread.getActiveSheet();
var table = getActiveSheetTable(sheet);
if (table) {
table.bandRows(_getElementById("bandRows").checked);
sheet.invalidateLayout();
sheet.repaint();
}
});
_getElementById("bandColumns").addEventListener('change', function() {
var sheet = spread.getActiveSheet();
var table = getActiveSheetTable(sheet);
if (table) {
table.bandColumns(_getElementById("bandColumns").checked);
sheet.invalidateLayout();
sheet.repaint();
}
});
//change table style
_getElementById("tableStyles").addEventListener('change', function() {
var sheet = spread.getActiveSheet();
var table = getActiveSheetTable(sheet);
if (table) {
var styleName = _getElementById("tableStyles").value;
table.style(styleName);
sheet.repaint();
}
});
function updateTableStyle(themeName) {
var obj = _getElementById("tableStyles");
if (themeName) {
obj.value = themeName;
}
}
spread.bind(GC.Spread.Sheets.Events.EnterCell, (eventType, data) => {
if (data) {
let activeSheet = spread.getActiveSheet();
let activeTable = activeSheet.tables.find(activeSheet.getActiveRowIndex(), activeSheet.getActiveColumnIndex());
if (activeTable) {
let style = activeTable.style(), name = 'None';
if (style) {
name = style.name();
}
updateTableStyle(name);
}
}
});
}
function _getElementById(id) {
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="data.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<p>Select the table in the Spread instance and change the style and properties using the checkboxes and drop-down menu.</p>
<div class="option-group">
<input type="checkbox" id="showHeader" checked/>
<label for="showHeader">Header Row</label>
</div>
<div class="option-group">
<input type="checkbox" id="highlightFirstColumn" />
<label for="highlightFirstColumn">First Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="showFooter"/>
<label for="showFooter">Total Row</label>
</div>
<div class="option-group">
<input type="checkbox" id="highlightLastColumn" />
<label for="highlightLastColumn">Last Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="bandColumns" />
<label for="bandColumns">Banded Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="bandRows" checked />
<label for="bandRows">Banded Row</label>
</div>
<div class="option-group">
<label for="tableStyles">Styles:</label>
<select id="tableStyles">
<option value="Light1">Light1</option>
<option value="Light2">Light2</option>
<option value="Light3">Light3</option>
<option value="Light4">Light4</option>
<option value="Light5">Light5</option>
<option value="Light6">Light6</option>
<option value="Light7">Light7</option>
<option value="Light8">Light8</option>
<option value="Light9">Light9</option>
<option value="Light10">Light10</option>
<option value="Light11">Light11</option>
<option value="Light12">Light12</option>
<option value="Light13">Light13</option>
<option value="Light14">Light14</option>
<option value="Light15">Light15</option>
<option value="Light16">Light16</option>
<option value="Light17">Light17</option>
<option value="Light18">Light18</option>
<option value="Light19">Light19</option>
<option value="Light20">Light20</option>
<option value="Light21">Light21</option>
<option value="Medium1">Medium1</option>
<option value="Medium2">Medium2</option>
<option value="Medium3">Medium3</option>
<option value="Medium4">Medium4</option>
<option value="Medium5">Medium5</option>
<option value="Medium6">Medium6</option>
<option value="Medium7">Medium7</option>
<option value="Medium8">Medium8</option>
<option value="Medium9">Medium9</option>
<option value="Medium10">Medium10</option>
<option value="Medium11">Medium11</option>
<option value="Medium12">Medium12</option>
<option value="Medium13">Medium13</option>
<option value="Medium14">Medium14</option>
<option value="Medium15">Medium15</option>
<option value="Medium16">Medium16</option>
<option value="Medium17">Medium17</option>
<option value="Medium18">Medium18</option>
<option value="Medium19">Medium19</option>
<option value="Medium20">Medium20</option>
<option value="Medium21">Medium21</option>
<option value="Medium22">Medium22</option>
<option value="Medium23">Medium23</option>
<option value="Medium24">Medium24</option>
<option value="Medium25">Medium25</option>
<option value="Medium26">Medium26</option>
<option value="Medium27">Medium27</option>
<option value="Medium28">Medium28</option>
<option value="Dark1">Dark1</option>
<option value="Dark2">Dark2</option>
<option value="Dark3">Dark3</option>
<option value="Dark4">Dark4</option>
<option value="Dark5">Dark5</option>
<option value="Dark6">Dark6</option>
<option value="Dark7">Dark7</option>
<option value="Dark8">Dark8</option>
<option value="Dark9">Dark9</option>
<option value="Dark10">Dark10</option>
<option value="Dark11">Dark11</option>
<option value="None" selected>None</option>
</select>
</div>
</div>
</div>
</body>
</html>
var jsonData = {
version: "16.0.0",
name: "",
sheetCount: 2,
customList: [],
activeSheetIndex: 1,
sheets: {
Table: {
name: "Table",
isSelected: false,
activeRow: 38,
activeCol: 2,
visible: 1,
theme: {
name: "Office",
themeColor: {
name: "Office",
background1: { a: 255, r: 255, g: 255, b: 255 },
background2: { a: 255, r: 231, g: 230, b: 230 },
text1: { a: 255, r: 0, g: 0, b: 0 },
text2: { a: 255, r: 68, g: 84, b: 106 },
accent1: { a: 255, r: 91, g: 155, b: 213 },
accent2: { a: 255, r: 237, g: 125, b: 49 },
accent3: { a: 255, r: 165, g: 165, b: 165 },
accent4: { a: 255, r: 255, g: 192, b: 0 },
accent5: { a: 255, r: 68, g: 114, b: 196 },
accent6: { a: 255, r: 112, g: 173, b: 71 },
hyperlink: { a: 255, r: 5, g: 99, b: 193 },
followedHyperlink: { a: 255, r: 149, g: 79, b: 114 },
},
headingFont: "'Calibri Light'",
bodyFont: "Calibri",
font: { headerFont: "'Calibri Light'", bodyFont: "Calibri" },
},
data: {
dataTable: {
0: {
0: { value: "SalesPers" },
1: { value: "Region" },
2: { value: "SaleAmt" },
3: { value: "ComPct" },
4: { value: "ComAmt" },
},
1: {
0: { value: "Joe" },
1: { value: "North" },
2: { value: 260 },
3: { value: 0.1 },
4: { value: 26, formula: { si: 0 } },
},
2: {
0: { value: "Robert" },
1: { value: "South" },
2: { value: 660 },
3: { value: 0.15 },
4: { value: 99, formula: { si: 0 } },
},
3: {
0: { value: "Michelle" },
1: { value: "East" },
2: { value: 940 },
3: { value: 0.15 },
4: { value: 141, formula: { si: 0 } },
},
4: {
0: { value: "Erich" },
1: { value: "West" },
2: { value: 410 },
3: { value: 0.12 },
4: { value: 49.2, formula: { si: 0 } },
},
5: {
0: { value: "Dafna" },
1: { value: "North" },
2: { value: 800 },
3: { value: 0.15 },
4: { value: 120, formula: { si: 0 } },
},
6: {
0: { value: "Robert" },
1: { value: "South" },
2: { value: 900 },
3: { value: 0.15 },
4: { value: 135, formula: { si: 0 } },
}
},
defaultDataNode: {
style: {
backColor: null,
foreColor: "Text 1 0",
vAlign: 2,
font: "normal normal 14.6667px Calibri",
themeFont: "Body",
borderLeft: null,
borderTop: null,
borderRight: null,
borderBottom: null,
locked: true,
textIndent: 0,
wordWrap: false,
shrinkToFit: false,
textDecoration: 0,
isVerticalText: false,
textOrientation: 0,
fontStyle: "normal",
fontWeight: "normal",
fontSize: "14.6667px",
fontFamily: "Calibri",
},
},
},
rowHeaderData: { defaultDataNode: { style: { themeFont: "Body" } } },
colHeaderData: { defaultDataNode: { style: { themeFont: "Body" } } },
columns: [
{ size: 81 },
{ size: 65 },
{ size: 74 },
{ size: 69 },
{ size: 76 },
],
defaultData: {},
leftCellIndex: 0,
topCellIndex: 0,
selections: {
0: { row: 38, col: 2, rowCount: 1, colCount: 1 },
length: 1,
},
defaults: {
colHeaderRowHeight: 20,
colWidth: 64,
rowHeaderColWidth: 40,
rowHeight: 20,
_isExcelDefaultColumnWidth: true,
},
rowOutlines: { items: [] },
columnOutlines: { items: [] },
cellStates: {},
states: {},
outlineColumnOptions: {},
autoMergeRangeInfos: [],
tables: [
{
name: "Table1",
row: 0,
col: 0,
rowCount: 7,
colCount: 5,
rowFilter: {
range: { row: 1, col: 0, rowCount: 6, colCount: 5 },
typeName: "HideRowFilter",
dialogVisibleInfo: {},
filterButtonVisibleInfo: {
0: true,
1: true,
2: true,
3: true,
4: true,
},
showFilterButton: true,
filteredOutRows: [],
tableName: "Table1",
},
columns: [
{ id: 1, name: "SalesPers", footerValue: "Total" },
{ id: 2, name: "Region" },
{ id: 3, name: "SaleAmt" },
{ id: 4, name: "ComPct" },
{
id: 5,
name: "ComAmt",
footerFormula: "SUBTOTAL(109,Table1[ComAmt])",
dataAreaFormula: "C2*D2",
},
],
},
],
shapeCollectionOption: { snapMode: 0 },
sharedFormulas: {
0: {
formula: "C2*D2",
baseRow: 1,
baseColumn: 4,
lastRow: 6,
lastColumn: 4,
},
nextIndex: 1,
},
printInfo: {
showColumnHeader: 1,
showRowHeader: 1,
paperSize: { width: 850, height: 1100, kind: 1 },
},
index: 0,
order: 0,
},
TableWithLayoutStyle: {
name: "TableWithLayoutStyle",
isSelected: true,
activeRow: 5,
activeCol: 7,
visible: 1,
theme: {
name: "Office",
themeColor: {
name: "Office",
background1: { a: 255, r: 255, g: 255, b: 255 },
background2: { a: 255, r: 231, g: 230, b: 230 },
text1: { a: 255, r: 0, g: 0, b: 0 },
text2: { a: 255, r: 68, g: 84, b: 106 },
accent1: { a: 255, r: 91, g: 155, b: 213 },
accent2: { a: 255, r: 237, g: 125, b: 49 },
accent3: { a: 255, r: 165, g: 165, b: 165 },
accent4: { a: 255, r: 255, g: 192, b: 0 },
accent5: { a: 255, r: 68, g: 114, b: 196 },
accent6: { a: 255, r: 112, g: 173, b: 71 },
hyperlink: { a: 255, r: 5, g: 99, b: 193 },
followedHyperlink: { a: 255, r: 149, g: 79, b: 114 },
},
headingFont: "'Calibri Light'",
bodyFont: "Calibri",
font: { headerFont: "'Calibri Light'", bodyFont: "Calibri" },
},
data: {
dataTable: {
0: {
0: { value: "SalesPers" },
1: { value: "Region" },
2: { value: "SaleAmt" },
3: { value: "ComPct" },
4: { value: "ComAmt" },
8: {
value:
"Add record to the table, see the auto-expanded table layout style",
},
},
1: {
0: { value: "Joe" },
1: { value: "North" },
2: { value: 260 },
3: { value: 0.1 },
4: { value: 26, formula: { si: 0 } },
8: {
value: "The table layout style‘s priority is higher than the table theme",
},
},
2: {
0: { value: "Robert" },
1: { value: "South" },
2: { value: 660 },
3: { value: 0.15 },
4: { value: 99, formula: { si: 0 } },
8: {
value: "Usually 'Banded Row' and 'Banded Column' only have backColor setting, so check these two options may take no effect",
},
},
3: {
0: { value: "Michelle" },
1: { value: "East" },
2: { value: 940 },
3: { value: 0.15 },
4: { value: 141, formula: { si: 0 } },
},
4: {
0: { value: "Erich" },
1: { value: "West" },
2: { value: 410 },
3: { value: 0.12 },
4: { value: 49.2, formula: { si: 0 } },
},
5: {
0: { value: "Dafna" },
1: { value: "North" },
2: { value: 800 },
3: { value: 0.15 },
4: { value: 120, formula: { si: 0 } },
},
6: {
0: { value: "Robert" },
1: { value: "South" },
2: { value: 900 },
3: { value: 0.15 },
4: { value: 135, formula: { si: 0 } },
},
},
defaultDataNode: {
style: {
backColor: null,
foreColor: "Text 1 0",
vAlign: 2,
font: "normal normal 14.6667px Calibri",
themeFont: "Body",
borderLeft: null,
borderTop: null,
borderRight: null,
borderBottom: null,
locked: true,
textIndent: 0,
wordWrap: false,
shrinkToFit: false,
textDecoration: 0,
isVerticalText: false,
textOrientation: 0,
fontStyle: "normal",
fontWeight: "normal",
fontSize: "14.6667px",
fontFamily: "Calibri",
},
},
},
rowHeaderData: { defaultDataNode: { style: { themeFont: "Body" } } },
colHeaderData: { defaultDataNode: { style: { themeFont: "Body" } } },
columns: [
{ size: 81 },
{ size: 65 },
{ size: 74 },
{ size: 69 },
{ size: 76 },
],
defaultData: {},
leftCellIndex: 0,
topCellIndex: 0,
selections: {
0: { row: 5, col: 7, rowCount: 1, colCount: 1 },
length: 1,
},
defaults: {
colHeaderRowHeight: 20,
colWidth: 64,
rowHeaderColWidth: 40,
rowHeight: 20,
_isExcelDefaultColumnWidth: true,
},
rowOutlines: { items: [] },
columnOutlines: { items: [] },
cellStates: {},
states: {},
outlineColumnOptions: {},
autoMergeRangeInfos: [],
tables: [
{
name: "Table2",
row: 0,
col: 0,
rowCount: 7,
colCount: 5,
rowFilter: {
range: { row: 1, col: 0, rowCount: 6, colCount: 5 },
typeName: "HideRowFilter",
dialogVisibleInfo: {},
filterButtonVisibleInfo: {
0: true,
1: true,
2: true,
3: true,
4: true,
},
showFilterButton: true,
filteredOutRows: [],
tableName: "Table2",
},
columns: [
{ id: 1, name: "SalesPers", footerValue: "Total" },
{ id: 2, name: "Region" },
{ id: 3, name: "SaleAmt" },
{ id: 4, name: "ComPct" },
{
id: 5,
name: "ComAmt",
footerFormula: "SUBTOTAL(109,Table2[ComAmt])",
dataAreaFormula: "C2*D2",
},
],
},
],
shapeCollectionOption: { snapMode: 0 },
sharedFormulas: {
0: {
formula: "C2*D2",
baseRow: 1,
baseColumn: 4,
lastRow: 6,
lastColumn: 4,
},
nextIndex: 1,
},
printInfo: {
showColumnHeader: 1,
showRowHeader: 1,
paperSize: { width: 850, height: 1100, kind: 1 },
},
index: 1,
order: 1,
},
},
sheetTabCount: 0,
namedPatterns: {},
pivotCaches: {},
};
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin-bottom: 6px;
}
select {
padding: 4px 6px;
}
p {
padding: 0 0 12px;
margin: 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

You can control whether to show the table's header or footer, whether to display an alternating row style or column style, and whether to highlight the first column or the last column. For example:
SpreadJS supports built-in table styles or you can customize the table style. For example:
SpreadJS supports customize the style of the table header, data or footer, the table column header, data or footer. Using code such as the following:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import Panel from './panel.jsx';
function setStyles(sheet) {
let table = sheet.tables.all()[0];
sheet.suspendPaint();
let tableHeaderStyle = new GC.Spread.Sheets.Style();
tableHeaderStyle.backColor = "Accent 1 80";
let tableDataStyle = new GC.Spread.Sheets.Style();
tableDataStyle.backColor = "Accent 4 80";
let tableFooterStyle = new GC.Spread.Sheets.Style();
tableFooterStyle.backColor = "Accent 6 80";
table.layoutStyle({
header: tableHeaderStyle,
data: tableDataStyle,
footer: tableFooterStyle
});
let tableColumnHeaderStyle = new GC.Spread.Sheets.Style();
tableColumnHeaderStyle.backColor = "Accent 1 40";
let tableColumnDataStyle = new GC.Spread.Sheets.Style();
tableColumnDataStyle.backColor = "Accent 4 40";
let tableColumnFooterStyle = new GC.Spread.Sheets.Style();
tableColumnFooterStyle.backColor = "Accent 6 40";
table.columnLayoutStyle(1, {
header: tableColumnHeaderStyle,
data: tableColumnDataStyle,
footer: tableColumnFooterStyle
});
let tableColumn3DataStyle = new GC.Spread.Sheets.Style();
tableColumn3DataStyle.formatter = "0%";
table.columnLayoutStyle(3, {
data: tableColumn3DataStyle
});
sheet.resumePaint();
}
function initCustomThemes(spread) {
const theme1 = new GC.Spread.Sheets.Tables.TableTheme();
theme1.name('custom1');
theme1.wholeTableStyle(new GC.Spread.Sheets.Tables.TableStyle('#e0f2f1'));
theme1.headerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.firstRowStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#b2dfdb'));
theme1.firstColumnStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#b2dfdb'));
theme1.footerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.highlightFirstColumnStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.highlightLastColumnStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
const theme2 = new GC.Spread.Sheets.Tables.TableTheme();
theme2.name('custom2');
theme2.wholeTableStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6'));
theme2.headerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6', '#000'));
theme2.firstRowStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#e1bee7'));
theme2.firstColumnStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#e1bee7'));
theme2.footerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6', '#000'));
spread.customTableThemes.add(theme1);
spread.customTableThemes.add(theme2);
}
const tableStylesList = {
0: "Light1",
1: "Light2",
2: "Light3",
3: "Light4",
4: "Light5",
5: "Light6",
6: "Light7",
7: "Light8",
8: "Light9",
9: "Light10",
10: "Light11",
11: "Light12",
12: "Light13",
13: "Light14",
14: "Light15",
15: "Light16",
16: "Light17",
17: "Light18",
18: "Light19",
19: "Light20",
20: "Light21",
21: "Medium1",
22: "Medium2",
23: "Medium3",
24: "Medium4",
25: "Medium5",
26: "Medium6",
27: "Medium7",
28: "Medium8",
29: "Medium9",
30: "Medium10",
31: "Medium11",
32: "Medium12",
33: "Medium13",
34: "Medium14",
35: "Medium15",
36: "Medium16",
37: "Medium17",
38: "Medium18",
39: "Medium19",
40: "Medium20",
41: "Medium21",
42: "Medium22",
43: "Medium23",
44: "Medium24",
45: "Medium25",
46: "Medium26",
47: "Medium27",
48: "Medium28",
49: "Dark1",
50: "Dark2",
51: "Dark3",
52: "Dark4",
53: "Dark5",
54: "Dark6",
55: "Dark7",
56: "Dark8",
57: "Dark9",
58: "Dark10",
59: "Dark11",
60: "None",
61: "Custom1",
62: "Custom2",
};
let spread = null;
export function AppFunc() {
const [styleOption, setStyleOption] = React.useState({
isShowHeader: true,
isHighlightFirstColumn: false,
isShowFooter: false,
isHighlightLastColumn: false,
isBandColumns: false,
isBandRows: true,
styleType: 'None'
});
const initSpread = (currSpread) => {
spread = currSpread;
spread.fromJSON(jsonData);
initCustomThemes(spread);
let sheet = spread.getActiveSheet();
setStyles(sheet);
spread.bind(GC.Spread.Sheets.Events.EnterCell, (eventType, data) => {
if (data) {
let activeSheet = spread.getActiveSheet();
let activeTable = activeSheet.tables.find(activeSheet.getActiveRowIndex(), activeSheet.getActiveColumnIndex());
if (activeTable) {
let style = activeTable.style(), name = 'None';
if (style) {
name = style.name();
}
setStyleOption({ ...styleOption, styleType: name });
}
}
});
}
const getActiveSheetTable = () => {
let sheet = spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex()) || sheet.tables.all()[0];
return { sheet, table };
}
const onShowHeader = (e) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
let checked = !styleOption.isShowHeader;
setStyleOption({ ...styleOption, isShowHeader: checked });
table.showHeader(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onShowFooter = (e) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
let checked = !styleOption.isShowFooter;
setStyleOption({ ...styleOption, isShowFooter: checked });
table.showFooter(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onHighlightFirstColumn = (e) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
let checked = !styleOption.isHighlightFirstColumn;
setStyleOption({ ...styleOption, isHighlightFirstColumn: checked });
table.highlightFirstColumn(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onHighlightLastColumn = (e) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
let checked = !styleOption.isHighlightLastColumn;
setStyleOption({ ...styleOption, isHighlightLastColumn: checked });
table.highlightLastColumn(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onBandRows = (e) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
let checked = !styleOption.isBandRows;
setStyleOption({ ...styleOption, isBandRows: checked });
table.bandRows(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onBandColumns = (e) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
let checked = !styleOption.isBandColumns;
setStyleOption({ ...styleOption, isBandColumns: checked });
table.bandColumns(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onStyleTypeChange = (e) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
let value = e.target.value;
setStyleOption({ ...styleOption, styleType: value });
table.style(value);
sheet.repaint();
}
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
tableStylesList={tableStylesList}
isShowHeader={styleOption.isShowHeader}
isHighlightFirstColumn={styleOption.isHighlightFirstColumn}
isShowFooter={styleOption.isShowFooter}
isHighlightLastColumn={styleOption.isHighlightLastColumn}
isBandColumns={styleOption.isBandColumns}
isBandRows={styleOption.isBandRows}
styleType={styleOption.styleType}
onShowHeader={(e) => { onShowHeader(e) }}
onHighlightFirstColumn={(e) => { onHighlightFirstColumn(e) }}
onShowFooter={(e) => { onShowFooter(e) }}
onHighlightLastColumn={(e) => { onHighlightLastColumn(e) }}
onBandColumns={(e) => { onBandColumns(e) }}
onBandRows={(e) => { onBandRows(e) }}
onStyleTypeChange={(e) => { onStyleTypeChange(e) }}
/>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets } from '@mescius/spread-sheets-react';
import Panel from './panel.jsx';
const Component = React.Component;
function setStyles(sheet) {
let table = sheet.tables.all()[0];
sheet.suspendPaint();
let tableHeaderStyle = new GC.Spread.Sheets.Style();
tableHeaderStyle.backColor = "Accent 1 80";
let tableDataStyle = new GC.Spread.Sheets.Style();
tableDataStyle.backColor = "Accent 4 80";
let tableFooterStyle = new GC.Spread.Sheets.Style();
tableFooterStyle.backColor = "Accent 6 80";
table.layoutStyle({
header: tableHeaderStyle,
data: tableDataStyle,
footer: tableFooterStyle
});
let tableColumnHeaderStyle = new GC.Spread.Sheets.Style();
tableColumnHeaderStyle.backColor = "Accent 1 40";
let tableColumnDataStyle = new GC.Spread.Sheets.Style();
tableColumnDataStyle.backColor = "Accent 4 40";
let tableColumnFooterStyle = new GC.Spread.Sheets.Style();
tableColumnFooterStyle.backColor = "Accent 6 40";
table.columnLayoutStyle(1, {
header: tableColumnHeaderStyle,
data: tableColumnDataStyle,
footer: tableColumnFooterStyle
});
let tableColumn3DataStyle = new GC.Spread.Sheets.Style();
tableColumn3DataStyle.formatter = "0%";
table.columnLayoutStyle(3, {
data: tableColumn3DataStyle
});
sheet.resumePaint();
}
function initCustomThemes(spread) {
const theme1 = new GC.Spread.Sheets.Tables.TableTheme();
theme1.name('custom1');
theme1.wholeTableStyle(new GC.Spread.Sheets.Tables.TableStyle('#e0f2f1'));
theme1.headerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.firstRowStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#b2dfdb'));
theme1.firstColumnStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#b2dfdb'));
theme1.footerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.highlightFirstColumnStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.highlightLastColumnStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
const theme2 = new GC.Spread.Sheets.Tables.TableTheme();
theme2.name('custom2');
theme2.wholeTableStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6'));
theme2.headerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6', '#000'));
theme2.firstRowStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#e1bee7'));
theme2.firstColumnStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#e1bee7'));
theme2.footerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6', '#000'));
spread.customTableThemes.add(theme1);
spread.customTableThemes.add(theme2);
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.tableStylesList = {
0: "Light1",
1: "Light2",
2: "Light3",
3: "Light4",
4: "Light5",
5: "Light6",
6: "Light7",
7: "Light8",
8: "Light9",
9: "Light10",
10: "Light11",
11: "Light12",
12: "Light13",
13: "Light14",
14: "Light15",
15: "Light16",
16: "Light17",
17: "Light18",
18: "Light19",
19: "Light20",
20: "Light21",
21: "Medium1",
22: "Medium2",
23: "Medium3",
24: "Medium4",
25: "Medium5",
26: "Medium6",
27: "Medium7",
28: "Medium8",
29: "Medium9",
30: "Medium10",
31: "Medium11",
32: "Medium12",
33: "Medium13",
34: "Medium14",
35: "Medium15",
36: "Medium16",
37: "Medium17",
38: "Medium18",
39: "Medium19",
40: "Medium20",
41: "Medium21",
42: "Medium22",
43: "Medium23",
44: "Medium24",
45: "Medium25",
46: "Medium26",
47: "Medium27",
48: "Medium28",
49: "Dark1",
50: "Dark2",
51: "Dark3",
52: "Dark4",
53: "Dark5",
54: "Dark6",
55: "Dark7",
56: "Dark8",
57: "Dark9",
58: "Dark10",
59: "Dark11",
60: "None",
61: "Custom1",
62: "Custom2",
};
this.state = {
isShowHeader: true,
isHighlightFirstColumn: false,
isShowFooter: false,
isHighlightLastColumn: false,
isBandColumns: false,
isBandRows: true,
styleType: 'None'
};
}
render() {
const {
isShowHeader,
isHighlightFirstColumn,
isShowFooter,
isHighlightLastColumn,
isBandColumns,
isBandRows,
styleType
} = this.state;
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
tableStylesList={this.tableStylesList}
isShowHeader={isShowHeader}
isHighlightFirstColumn={isHighlightFirstColumn}
isShowFooter={isShowFooter}
isHighlightLastColumn={isHighlightLastColumn}
isBandColumns={isBandColumns}
isBandRows={isBandRows}
styleType={styleType}
onShowHeader={(e) => { this.onShowHeader(e) }}
onHighlightFirstColumn={(e) => { this.onHighlightFirstColumn(e) }}
onShowFooter={(e) => { this.onShowFooter(e) }}
onHighlightLastColumn={(e) => { this.onHighlightLastColumn(e) }}
onBandColumns={(e) => { this.onBandColumns(e) }}
onBandRows={(e) => { this.onBandRows(e) }}
onStyleTypeChange={(e) => { this.onStyleTypeChange(e) }}
/>
</div>
);
}
initSpread(spread) {
let self = this;
self.spread = spread;
spread.fromJSON(jsonData);
initCustomThemes(spread);
let sheet = spread.getActiveSheet();
setStyles(sheet);
spread.bind(GC.Spread.Sheets.Events.EnterCell, (eventType, data) => {
if (data) {
let activeSheet = spread.getActiveSheet();
let activeTable = activeSheet.tables.find(activeSheet.getActiveRowIndex(), activeSheet.getActiveColumnIndex());
if (activeTable) {
let style = activeTable.style(), name = 'None';
if (style) {
name = style.name();
}
self.setState({ styleType: name });
}
}
});
}
getActiveSheetTable() {
let sheet = this.spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex()) || sheet.tables.all()[0];
return { sheet, table };
}
onShowHeader(e) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = !this.state.isShowHeader;
this.setState({ isShowHeader: checked });
table.showHeader(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onShowFooter(e) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = !this.state.isShowFooter;
this.setState({ isShowFooter: checked });
table.showFooter(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onHighlightFirstColumn(e) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = !this.state.isHighlightFirstColumn;
this.setState({ isHighlightFirstColumn: checked });
table.highlightFirstColumn(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onHighlightLastColumn(e) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = !this.state.isHighlightLastColumn;
this.setState({ isHighlightLastColumn: checked });
table.highlightLastColumn(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onBandRows(e) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = !this.state.isBandRows;
this.setState({ isBandRows: checked });
table.bandRows(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onBandColumns(e) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = !this.state.isBandColumns;
this.setState({ isBandColumns: checked });
table.bandColumns(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onStyleTypeChange(e) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let value = e.target.value;
this.setState({ styleType: value });
table.style(value);
sheet.repaint();
}
}
}
import * as React from 'react';
export default function Panel(props){
const {
tableStylesList,
isShowHeader,
isHighlightFirstColumn,
isShowFooter,
isHighlightLastColumn,
isBandColumns,
isBandRows,
styleType,
onShowHeader,
onHighlightFirstColumn,
onShowFooter,
onHighlightLastColumn,
onBandColumns,
onBandRows,
onStyleTypeChange
} = props;
return (
<div class="options-container">
<p>Select the table in the Spread instance and change the style and properties using the checkboxes and drop-down menu.</p>
<div class="option-group">
<input type="checkbox" id="showHeader" checked={isShowHeader} onChange={(e)=>{onShowHeader(e)}} />
<label for="showHeader">Header Row</label>
</div>
<div class="option-group">
<input type="checkbox" id="highlightFirstColumn" checked={isHighlightFirstColumn} onChange={(e)=>{onHighlightFirstColumn(e)}} />
<label for="highlightFirstColumn">First Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="showFooter" checked={isShowFooter} onChange={(e)=>{onShowFooter(e)}} />
<label for="showFooter">Total Row</label>
</div>
<div class="option-group">
<input type="checkbox" id="highlightLastColumn" checked={isHighlightLastColumn} onChange={(e)=>{onHighlightLastColumn(e)}} />
<label for="highlightLastColumn">Last Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="bandColumns" checked={isBandColumns} onChange={(e)=>{onBandColumns(e)}} />
<label for="bandColumns">Banded Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="bandRows" checked={isBandRows} onChange={(e)=>{onBandRows(e)}} />
<label for="bandRows">Banded Row</label>
</div>
<div class="option-group">
<label for="tableStyles">Styles:</label>
<select id="tableStyles" value={styleType} onChange={(e)=>{onStyleTypeChange(e)}}>
{
Object.keys(tableStylesList).map((key) => {
return <option value={tableStylesList[key]} key={key}>{tableStylesList[key]}</option>
})
}
</select>
</div>
</div>
);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin-bottom: 6px;
}
select {
padding: 4px 6px;
}
p {
padding: 0 0 12px;
margin: 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can control whether to show the table's header or footer, whether to display an alternating row style or column style, and whether to highlight the first column or the last column. For example:
SpreadJS supports built-in table styles or you can customize the table style. For example:
SpreadJS supports customize the style of the table header, data or footer, the table column header, data or footer. Using code such as the following:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const spreadNS = GC.Spread.Sheets;
const TableStyles = {
0: "Light1",
1: "Light2",
2: "Light3",
3: "Light4",
4: "Light5",
5: "Light6",
6: "Light7",
7: "Light8",
8: "Light9",
9: "Light10",
10: "Light11",
11: "Light12",
12: "Light13",
13: "Light14",
14: "Light15",
15: "Light16",
16: "Light17",
17: "Light18",
18: "Light19",
19: "Light20",
20: "Light21",
21: "Medium1",
22: "Medium2",
23: "Medium3",
24: "Medium4",
25: "Medium5",
26: "Medium6",
27: "Medium7",
28: "Medium8",
29: "Medium9",
30: "Medium10",
31: "Medium11",
32: "Medium12",
33: "Medium13",
34: "Medium14",
35: "Medium15",
36: "Medium16",
37: "Medium17",
38: "Medium18",
39: "Medium19",
40: "Medium20",
41: "Medium21",
42: "Medium22",
43: "Medium23",
44: "Medium24",
45: "Medium25",
46: "Medium26",
47: "Medium27",
48: "Medium28",
49: "Dark1",
50: "Dark2",
51: "Dark3",
52: "Dark4",
53: "Dark5",
54: "Dark6",
55: "Dark7",
56: "Dark8",
57: "Dark9",
58: "Dark10",
59: "Dark11",
60: "None"
};
function getArrayOfObject(object: object) {
let list = [];
for (let key in object) {
list.push({
key: key,
value: object[key]
});
}
return list;
}
function setStyles (sheet: any) {
let table = sheet.tables.all()[0];
sheet.suspendPaint();
let tableHeaderStyle = new GC.Spread.Sheets.Style();
tableHeaderStyle.backColor = "Accent 1 80";
let tableDataStyle = new GC.Spread.Sheets.Style();
tableDataStyle.backColor = "Accent 4 80";
let tableFooterStyle = new GC.Spread.Sheets.Style();
tableFooterStyle.backColor = "Accent 6 80";
table.layoutStyle({
header: tableHeaderStyle,
data: tableDataStyle,
footer: tableFooterStyle
});
let tableColumnHeaderStyle = new GC.Spread.Sheets.Style();
tableColumnHeaderStyle.backColor = "Accent 1 40";
let tableColumnDataStyle = new GC.Spread.Sheets.Style();
tableColumnDataStyle.backColor = "Accent 4 40";
let tableColumnFooterStyle = new GC.Spread.Sheets.Style();
tableColumnFooterStyle.backColor = "Accent 6 40";
table.columnLayoutStyle(1, {
header: tableColumnHeaderStyle,
data: tableColumnDataStyle,
footer: tableColumnFooterStyle
});
let tableColumn3DataStyle = new GC.Spread.Sheets.Style();
tableColumn3DataStyle.formatter = "0%";
table.columnLayoutStyle(3, {
data: tableColumn3DataStyle
});
sheet.resumePaint();
}
function initCustomThemes(spread: GC.Spread.Sheets.Workbook, tableStylesList: Array<{key: string; value: any;}>) {
const theme1 = new GC.Spread.Sheets.Tables.TableTheme();
theme1.name('custom1');
theme1.wholeTableStyle(new GC.Spread.Sheets.Tables.TableStyle('#e0f2f1'));
theme1.headerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.firstRowStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#b2dfdb'));
theme1.firstColumnStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#b2dfdb'));
theme1.footerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.highlightFirstColumnStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.highlightLastColumnStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
const theme2 = new GC.Spread.Sheets.Tables.TableTheme();
theme2.name('custom2');
theme2.wholeTableStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6'));
theme2.headerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6', '#000'));
theme2.firstRowStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#e1bee7'));
theme2.firstColumnStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#e1bee7'));
theme2.footerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6', '#000'));
spread.customTableThemes.add(theme1);
spread.customTableThemes.add(theme2);
const customThemes = spread.customTableThemes.all();
if (customThemes && customThemes.length > 0) {
customThemes.forEach((theme) => {
tableStylesList.push({
key: theme.name(),
value: theme.name()
});
});
}
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
isShowHeader = true;
isHighlightFirstColumn = false;
isShowFooter = false;
isHighlightLastColumn = false;
isBandColumns = false;
isBandRows = true;
styleType = 'None';
tableStylesList = getArrayOfObject(TableStyles);
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
let self = this;
self.spread = $event.spread;
let spread = this.spread;
spread.fromJSON(jsonData);
initCustomThemes(spread, self.tableStylesList)
let sheet = spread.getActiveSheet();
setStyles(sheet);
spread.bind(GC.Spread.Sheets.Events.EnterCell, (eventType: any, data: any) => {
if (data) {
let activeSheet = spread.getActiveSheet();
let activeTable = activeSheet.tables.find(activeSheet.getActiveRowIndex(), activeSheet.getActiveColumnIndex());
if (activeTable) {
let style = activeTable.style(), name = 'None';
if (style) {
name = style.name();
}
self.styleType = name;
}
}
});
}
getActiveSheetTable () {
let sheet = this.spread.getActiveSheet();
let table = sheet.tables.find(sheet.getActiveRowIndex(), sheet.getActiveColumnIndex()) || sheet.tables.all()[0];
return { sheet, table };
}
onShowHeader (e: any) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = e.target.checked;
this.isShowHeader = checked;
table.showHeader(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onShowFooter (e: any) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = e.target.checked;
this.isShowFooter = checked;
table.showFooter(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onHighlightFirstColumn (e: any) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = e.target.checked;
this.isHighlightFirstColumn = checked;
table.highlightFirstColumn(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onHighlightLastColumn (e: any) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = e.target.checked;
this.isHighlightLastColumn = checked;
table.highlightLastColumn(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onBandRows (e: any) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = e.target.checked;
this.isBandRows = checked;
table.bandRows(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onBandColumns (e: any) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let checked = e.target.checked;
this.isBandColumns = checked;
table.bandColumns(checked);
sheet.invalidateLayout();
sheet.repaint();
}
}
onStyleTypeChange (e: any) {
let { sheet, table } = this.getActiveSheetTable();
if (table) {
let value = e.target.value;
this.styleType = value;
table.style(value);
sheet.repaint();
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<p>Select the table in the Spread instance and change the style and properties using the checkboxes and drop-down menu.</p>
<div class="option-group">
<input type="checkbox" id="showHeader" [checked]="isShowHeader" (change)="onShowHeader($event)" />
<label for="showHeader">Header Row</label>
</div>
<div class="option-group">
<input type="checkbox" id="highlightFirstColumn" [checked]="isHighlightFirstColumn" (change)="onHighlightFirstColumn($event)" />
<label for="highlightFirstColumn">First Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="showFooter" [checked]="isShowFooter" (change)="onShowFooter($event)" />
<label for="showFooter">Total Row</label>
</div>
<div class="option-group">
<input type="checkbox" id="highlightLastColumn" [checked]="isHighlightLastColumn" (change)="onHighlightLastColumn($event)" />
<label for="highlightLastColumn">Last Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="bandColumns" [checked]="isBandColumns" (change)="onBandColumns($event)" />
<label for="bandColumns">Banded Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="bandRows" [checked]="isBandRows" (change)="onBandRows($event)" />
<label for="bandRows">Banded Row</label>
</div>
<div class="option-group">
<label for="tableStyles">Styles:</label>
<select id="tableStyles" [(ngModel)]="styleType" (change)="onStyleTypeChange($event)">
<option *ngFor="let item of tableStylesList" [value]="item.value">
{{item.value}}
</option>
</select>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin-bottom: 6px;
}
select {
padding: 4px 6px;
}
p {
padding: 0 0 12px;
margin: 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

You can control whether to show the table's header or footer, whether to display an alternating row style or column style, and whether to highlight the first column or the last column. For example:
SpreadJS supports built-in table styles or you can customize the table style. For example:
SpreadJS supports customize the style of the table header, data or footer, the table column header, data or footer. Using code such as the following:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"></gc-spread-sheets>
<panel v-bind:tableStylesList="tableStylesList" @onShowHeader="onShowHeader"
@onHighlightFirstColumn="onHighlightFirstColumn" @onShowFooter="onShowFooter"
@onHighlightLastColumn="onHighlightLastColumn" @onBandColumns="onBandColumns" @onBandRows="onBandRows"
@onStyleTypeChange="onStyleTypeChange"></panel>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import { ref } from "vue";
import Panel from "./panel.vue";
import GC from "@mescius/spread-sheets";
const spreadNS = GC.Spread.Sheets;
let spreadRef;
const tableStylesList = ref({
0: "Light1",
1: "Light2",
2: "Light3",
3: "Light4",
4: "Light5",
5: "Light6",
6: "Light7",
7: "Light8",
8: "Light9",
9: "Light10",
10: "Light11",
11: "Light12",
12: "Light13",
13: "Light14",
14: "Light15",
15: "Light16",
16: "Light17",
17: "Light18",
18: "Light19",
19: "Light20",
20: "Light21",
21: "Medium1",
22: "Medium2",
23: "Medium3",
24: "Medium4",
25: "Medium5",
26: "Medium6",
27: "Medium7",
28: "Medium8",
29: "Medium9",
30: "Medium10",
31: "Medium11",
32: "Medium12",
33: "Medium13",
34: "Medium14",
35: "Medium15",
36: "Medium16",
37: "Medium17",
38: "Medium18",
39: "Medium19",
40: "Medium20",
41: "Medium21",
42: "Medium22",
43: "Medium23",
44: "Medium24",
45: "Medium25",
46: "Medium26",
47: "Medium27",
48: "Medium28",
49: "Dark1",
50: "Dark2",
51: "Dark3",
52: "Dark4",
53: "Dark5",
54: "Dark6",
55: "Dark7",
56: "Dark8",
57: "Dark9",
58: "Dark10",
59: "Dark11",
60: "None",
61: "Custom1",
62: "Custom2"
});
function setStyles(sheet) {
let table = sheet.tables.all()[0];
sheet.suspendPaint();
let tableHeaderStyle = new GC.Spread.Sheets.Style();
tableHeaderStyle.backColor = "Accent 1 80";
let tableDataStyle = new GC.Spread.Sheets.Style();
tableDataStyle.backColor = "Accent 4 80";
let tableFooterStyle = new GC.Spread.Sheets.Style();
tableFooterStyle.backColor = "Accent 6 80";
table.layoutStyle({
header: tableHeaderStyle,
data: tableDataStyle,
footer: tableFooterStyle
});
let tableColumnHeaderStyle = new GC.Spread.Sheets.Style();
tableColumnHeaderStyle.backColor = "Accent 1 40";
let tableColumnDataStyle = new GC.Spread.Sheets.Style();
tableColumnDataStyle.backColor = "Accent 4 40";
let tableColumnFooterStyle = new GC.Spread.Sheets.Style();
tableColumnFooterStyle.backColor = "Accent 6 40";
table.columnLayoutStyle(1, {
header: tableColumnHeaderStyle,
data: tableColumnDataStyle,
footer: tableColumnFooterStyle
});
let tableColumn3DataStyle = new GC.Spread.Sheets.Style();
tableColumn3DataStyle.formatter = "0%";
table.columnLayoutStyle(3, {
data: tableColumn3DataStyle
});
sheet.resumePaint();
}
function initCustomThemes(spread) {
const theme1 = new GC.Spread.Sheets.Tables.TableTheme();
theme1.name('custom1');
theme1.wholeTableStyle(new GC.Spread.Sheets.Tables.TableStyle('#e0f2f1'));
theme1.headerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.firstRowStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#b2dfdb'));
theme1.firstColumnStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#b2dfdb'));
theme1.footerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.highlightFirstColumnStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
theme1.highlightLastColumnStyle(new GC.Spread.Sheets.Tables.TableStyle('#26a69a', '#fff'));
const theme2 = new GC.Spread.Sheets.Tables.TableTheme();
theme2.name('custom2');
theme2.wholeTableStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6'));
theme2.headerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6', '#000'));
theme2.firstRowStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#e1bee7'));
theme2.firstColumnStripStyle(new GC.Spread.Sheets.Tables.TableStyle('#e1bee7'));
theme2.footerRowStyle(new GC.Spread.Sheets.Tables.TableStyle('#ede7f6', '#000'));
spread.customTableThemes.add(theme1);
spread.customTableThemes.add(theme2);
}
const initSpread = (spread) => {
spreadRef = spread;
spread.fromJSON(jsonData);
initCustomThemes(spread);
let sheet = spread.getActiveSheet();
setStyles(sheet);
spread.bind(GC.Spread.Sheets.Events.EnterCell, (eventType, data) => {
if (data) {
let activeSheet = spread.getActiveSheet();
let activeTable = activeSheet.tables.find(activeSheet.getActiveRowIndex(), activeSheet.getActiveColumnIndex());
if (activeTable) {
let style = activeTable.style(), name = 'None';
if (style) {
name = style.name();
}
self.styleType = name;
}
}
});
}
const getActiveSheetTable = () => {
let sheet = spreadRef.getActiveSheet();
let table = sheet.tables.find(
sheet.getActiveRowIndex(),
sheet.getActiveColumnIndex()
) || sheet.tables.all()[0];
return { sheet, table };
}
const onShowHeader = (value) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
table.showHeader(value);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onShowFooter = (value) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
table.showFooter(value);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onHighlightFirstColumn = (value) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
table.highlightFirstColumn(value);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onHighlightLastColumn = (value) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
table.highlightLastColumn(value);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onBandRows = (value) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
table.bandRows(value);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onBandColumns = (value) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
table.bandColumns(value);
sheet.invalidateLayout();
sheet.repaint();
}
}
const onStyleTypeChange = (value) => {
let { sheet, table } = getActiveSheetTable();
if (table) {
table.style(value);
sheet.repaint();
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.option-group {
margin-bottom: 6px;
}
label {
display: inline-block;
min-width: 90px;
margin-bottom: 6px;
}
select {
padding: 4px 6px;
}
p {
padding: 0 0 12px;
margin: 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<template>
<div class="options-container">
<p>Select the table in the Spread instance and change the style and properties using the checkboxes and drop-down menu.</p>
<div class="option-group">
<input type="checkbox" id="showHeader" v-model="isShowHeader" v-on:change="onShowHeader" />
<label for="showHeader">Header Row</label>
</div>
<div class="option-group">
<input type="checkbox" id="highlightFirstColumn" v-model="isHighlightFirstColumn" v-on:change="onHighlightFirstColumn" />
<label for="highlightFirstColumn">First Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="showFooter" v-model="isShowFooter" v-on:change="onShowFooter" />
<label for="showFooter">Total Row</label>
</div>
<div class="option-group">
<input type="checkbox" id="highlightLastColumn" v-model="isHighlightLastColumn" v-on:change="onHighlightLastColumn" />
<label for="highlightLastColumn">Last Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="bandColumns" v-model="isBandColumns" v-on:change="onBandColumns" />
<label for="bandColumns">Banded Column</label>
</div>
<div class="option-group">
<input type="checkbox" id="bandRows" v-model="isBandRows" v-on:change="onBandRows" />
<label for="bandRows">Banded Row</label>
</div>
<div class="option-group">
<label for="tableStyles">Styles:</label>
<select id="tableStyles" v-model="styleType" v-on:change="onStyleTypeChange">
<option v-bind:value="item" v-for="(item, index) in tableStylesList" :key="index">{{ item }}</option>
</select>
</div>
</div>
</template>
<script>
export default {
props: [
"tableStylesList"
],
data: function () {
return {
isShowHeader: true,
isHighlightFirstColumn: false,
isShowFooter: false,
isHighlightLastColumn: false,
isBandColumns: false,
isBandRows: true,
styleType: 'None'
};
},
methods: {
onShowHeader() {
this.$emit("onShowHeader", this.isShowHeader);
},
onHighlightFirstColumn() {
this.$emit("onHighlightFirstColumn", this.isHighlightFirstColumn);
},
onShowFooter() {
this.$emit("onShowFooter", this.isShowFooter);
},
onHighlightLastColumn() {
this.$emit("onHighlightLastColumn", this.isHighlightLastColumn);
},
onBandColumns() {
this.$emit("onBandColumns", this.isBandColumns);
},
onBandRows() {
this.$emit("onBandRows", this.isBandRows);
},
onStyleTypeChange(event) {
this.$emit("onStyleTypeChange", this.styleType);
}
}
}
</script>
<style>
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="data.js" type="text/javascript"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
var jsonData = {
version: "16.0.0",
name: "",
sheetCount: 2,
customList: [],
activeSheetIndex: 1,
sheets: {
Table: {
name: "Table",
isSelected: false,
activeRow: 38,
activeCol: 2,
visible: 1,
theme: {
name: "Office",
themeColor: {
name: "Office",
background1: { a: 255, r: 255, g: 255, b: 255 },
background2: { a: 255, r: 231, g: 230, b: 230 },
text1: { a: 255, r: 0, g: 0, b: 0 },
text2: { a: 255, r: 68, g: 84, b: 106 },
accent1: { a: 255, r: 91, g: 155, b: 213 },
accent2: { a: 255, r: 237, g: 125, b: 49 },
accent3: { a: 255, r: 165, g: 165, b: 165 },
accent4: { a: 255, r: 255, g: 192, b: 0 },
accent5: { a: 255, r: 68, g: 114, b: 196 },
accent6: { a: 255, r: 112, g: 173, b: 71 },
hyperlink: { a: 255, r: 5, g: 99, b: 193 },
followedHyperlink: { a: 255, r: 149, g: 79, b: 114 },
},
headingFont: "'Calibri Light'",
bodyFont: "Calibri",
font: { headerFont: "'Calibri Light'", bodyFont: "Calibri" },
},
data: {
dataTable: {
0: {
0: { value: "SalesPers" },
1: { value: "Region" },
2: { value: "SaleAmt" },
3: { value: "ComPct" },
4: { value: "ComAmt" },
},
1: {
0: { value: "Joe" },
1: { value: "North" },
2: { value: 260 },
3: { value: 0.1 },
4: { value: 26, formula: { si: 0 } },
},
2: {
0: { value: "Robert" },
1: { value: "South" },
2: { value: 660 },
3: { value: 0.15 },
4: { value: 99, formula: { si: 0 } },
},
3: {
0: { value: "Michelle" },
1: { value: "East" },
2: { value: 940 },
3: { value: 0.15 },
4: { value: 141, formula: { si: 0 } },
},
4: {
0: { value: "Erich" },
1: { value: "West" },
2: { value: 410 },
3: { value: 0.12 },
4: { value: 49.2, formula: { si: 0 } },
},
5: {
0: { value: "Dafna" },
1: { value: "North" },
2: { value: 800 },
3: { value: 0.15 },
4: { value: 120, formula: { si: 0 } },
},
6: {
0: { value: "Robert" },
1: { value: "South" },
2: { value: 900 },
3: { value: 0.15 },
4: { value: 135, formula: { si: 0 } },
}
},
defaultDataNode: {
style: {
backColor: null,
foreColor: "Text 1 0",
vAlign: 2,
font: "normal normal 14.6667px Calibri",
themeFont: "Body",
borderLeft: null,
borderTop: null,
borderRight: null,
borderBottom: null,
locked: true,
textIndent: 0,
wordWrap: false,
shrinkToFit: false,
textDecoration: 0,
isVerticalText: false,
textOrientation: 0,
fontStyle: "normal",
fontWeight: "normal",
fontSize: "14.6667px",
fontFamily: "Calibri",
},
},
},
rowHeaderData: { defaultDataNode: { style: { themeFont: "Body" } } },
colHeaderData: { defaultDataNode: { style: { themeFont: "Body" } } },
columns: [
{ size: 81 },
{ size: 65 },
{ size: 74 },
{ size: 69 },
{ size: 76 },
],
defaultData: {},
leftCellIndex: 0,
topCellIndex: 0,
selections: {
0: { row: 38, col: 2, rowCount: 1, colCount: 1 },
length: 1,
},
defaults: {
colHeaderRowHeight: 20,
colWidth: 64,
rowHeaderColWidth: 40,
rowHeight: 20,
_isExcelDefaultColumnWidth: true,
},
rowOutlines: { items: [] },
columnOutlines: { items: [] },
cellStates: {},
states: {},
outlineColumnOptions: {},
autoMergeRangeInfos: [],
tables: [
{
name: "Table1",
row: 0,
col: 0,
rowCount: 7,
colCount: 5,
rowFilter: {
range: { row: 1, col: 0, rowCount: 6, colCount: 5 },
typeName: "HideRowFilter",
dialogVisibleInfo: {},
filterButtonVisibleInfo: {
0: true,
1: true,
2: true,
3: true,
4: true,
},
showFilterButton: true,
filteredOutRows: [],
tableName: "Table1",
},
columns: [
{ id: 1, name: "SalesPers", footerValue: "Total" },
{ id: 2, name: "Region" },
{ id: 3, name: "SaleAmt" },
{ id: 4, name: "ComPct" },
{
id: 5,
name: "ComAmt",
footerFormula: "SUBTOTAL(109,Table1[ComAmt])",
dataAreaFormula: "C2*D2",
},
],
},
],
shapeCollectionOption: { snapMode: 0 },
sharedFormulas: {
0: {
formula: "C2*D2",
baseRow: 1,
baseColumn: 4,
lastRow: 6,
lastColumn: 4,
},
nextIndex: 1,
},
printInfo: {
showColumnHeader: 1,
showRowHeader: 1,
paperSize: { width: 850, height: 1100, kind: 1 },
},
index: 0,
order: 0,
},
TableWithLayoutStyle: {
name: "TableWithLayoutStyle",
isSelected: true,
activeRow: 5,
activeCol: 7,
visible: 1,
theme: {
name: "Office",
themeColor: {
name: "Office",
background1: { a: 255, r: 255, g: 255, b: 255 },
background2: { a: 255, r: 231, g: 230, b: 230 },
text1: { a: 255, r: 0, g: 0, b: 0 },
text2: { a: 255, r: 68, g: 84, b: 106 },
accent1: { a: 255, r: 91, g: 155, b: 213 },
accent2: { a: 255, r: 237, g: 125, b: 49 },
accent3: { a: 255, r: 165, g: 165, b: 165 },
accent4: { a: 255, r: 255, g: 192, b: 0 },
accent5: { a: 255, r: 68, g: 114, b: 196 },
accent6: { a: 255, r: 112, g: 173, b: 71 },
hyperlink: { a: 255, r: 5, g: 99, b: 193 },
followedHyperlink: { a: 255, r: 149, g: 79, b: 114 },
},
headingFont: "'Calibri Light'",
bodyFont: "Calibri",
font: { headerFont: "'Calibri Light'", bodyFont: "Calibri" },
},
data: {
dataTable: {
0: {
0: { value: "SalesPers" },
1: { value: "Region" },
2: { value: "SaleAmt" },
3: { value: "ComPct" },
4: { value: "ComAmt" },
8: {
value:
"Add record to the table, see the auto-expanded table layout style",
},
},
1: {
0: { value: "Joe" },
1: { value: "North" },
2: { value: 260 },
3: { value: 0.1 },
4: { value: 26, formula: { si: 0 } },
8: {
value: "The table layout style‘s priority is higher than the table theme",
},
},
2: {
0: { value: "Robert" },
1: { value: "South" },
2: { value: 660 },
3: { value: 0.15 },
4: { value: 99, formula: { si: 0 } },
8: {
value: "Usually 'Banded Row' and 'Banded Column' only have backColor setting, so check these two options may take no effect",
},
},
3: {
0: { value: "Michelle" },
1: { value: "East" },
2: { value: 940 },
3: { value: 0.15 },
4: { value: 141, formula: { si: 0 } },
},
4: {
0: { value: "Erich" },
1: { value: "West" },
2: { value: 410 },
3: { value: 0.12 },
4: { value: 49.2, formula: { si: 0 } },
},
5: {
0: { value: "Dafna" },
1: { value: "North" },
2: { value: 800 },
3: { value: 0.15 },
4: { value: 120, formula: { si: 0 } },
},
6: {
0: { value: "Robert" },
1: { value: "South" },
2: { value: 900 },
3: { value: 0.15 },
4: { value: 135, formula: { si: 0 } },
},
},
defaultDataNode: {
style: {
backColor: null,
foreColor: "Text 1 0",
vAlign: 2,
font: "normal normal 14.6667px Calibri",
themeFont: "Body",
borderLeft: null,
borderTop: null,
borderRight: null,
borderBottom: null,
locked: true,
textIndent: 0,
wordWrap: false,
shrinkToFit: false,
textDecoration: 0,
isVerticalText: false,
textOrientation: 0,
fontStyle: "normal",
fontWeight: "normal",
fontSize: "14.6667px",
fontFamily: "Calibri",
},
},
},
rowHeaderData: { defaultDataNode: { style: { themeFont: "Body" } } },
colHeaderData: { defaultDataNode: { style: { themeFont: "Body" } } },
columns: [
{ size: 81 },
{ size: 65 },
{ size: 74 },
{ size: 69 },
{ size: 76 },
],
defaultData: {},
leftCellIndex: 0,
topCellIndex: 0,
selections: {
0: { row: 5, col: 7, rowCount: 1, colCount: 1 },
length: 1,
},
defaults: {
colHeaderRowHeight: 20,
colWidth: 64,
rowHeaderColWidth: 40,
rowHeight: 20,
_isExcelDefaultColumnWidth: true,
},
rowOutlines: { items: [] },
columnOutlines: { items: [] },
cellStates: {},
states: {},
outlineColumnOptions: {},
autoMergeRangeInfos: [],
tables: [
{
name: "Table2",
row: 0,
col: 0,
rowCount: 7,
colCount: 5,
rowFilter: {
range: { row: 1, col: 0, rowCount: 6, colCount: 5 },
typeName: "HideRowFilter",
dialogVisibleInfo: {},
filterButtonVisibleInfo: {
0: true,
1: true,
2: true,
3: true,
4: true,
},
showFilterButton: true,
filteredOutRows: [],
tableName: "Table2",
},
columns: [
{ id: 1, name: "SalesPers", footerValue: "Total" },
{ id: 2, name: "Region" },
{ id: 3, name: "SaleAmt" },
{ id: 4, name: "ComPct" },
{
id: 5,
name: "ComAmt",
footerFormula: "SUBTOTAL(109,Table2[ComAmt])",
dataAreaFormula: "C2*D2",
},
],
},
],
shapeCollectionOption: { snapMode: 0 },
sharedFormulas: {
0: {
formula: "C2*D2",
baseRow: 1,
baseColumn: 4,
lastRow: 6,
lastColumn: 4,
},
nextIndex: 1,
},
printInfo: {
showColumnHeader: 1,
showRowHeader: 1,
paperSize: { width: 850, height: 1100, kind: 1 },
},
index: 1,
order: 1,
},
},
sheetTabCount: 0,
namedPatterns: {},
pivotCaches: {},
};
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);